/*
  Melody_dkqbplay

  Plays a melody using QBasic PLAY command format

  circuit:
  
  Piezo-speaker on digital pin 8

  created 12 May 2018
  fixed  2 April 2020
  by Dmitriy Korabelnikov aka Deckard of Atomic Destruction
  e-mail:
  d_korabelnikov@mail.ru
  site:
  http://atd-group.narod.ru
*/ 
#define SPEAKER 8
#define LED 13
#define eq  ==
#define isdigit(a) (((a)>='0') && ((a)<='9'))
#define islower(a) (((a)>='a') && ((a)<='z'))
#define nota       pgm_read_byte(melody+i)

char octave=0;
char lendef=1;
char flagdiez=0;
int tempo=120;
char playmode='N';

//Select music array notes[]. Comment all other include strings
//char notes[]="T120MSo3L8CDEFGGL16GFL8EFFL16FEDL8CDG4";
//#include "elise.h"
//#include "undertc.h"
//#include "elka.h"
//#include "music.h"
//#include "jingle2.h"
//#include "marylamb.h"
//#include "merry.h"
//#include "silent.h"
//#include "bach1.h"
#include "inventio.h"

//hardware play tone itself. tone is a delay in microseconds (not frequancy),duration is a sound length in milliseconds
//If you don't want LED blinking, remove all operators with LED.
void playTone(unsigned int tone,unsigned int duration)
{digitalWrite(LED,HIGH);
  for (unsigned long i=0;i<duration*1000L;i+=(tone*2))
  {digitalWrite(SPEAKER,HIGH);
   delayMicroseconds(tone);
   digitalWrite(SPEAKER,LOW);
   delayMicroseconds(tone);
  }
digitalWrite(LED,LOW);
}

//converts note letter to tone,if correct calls playTone
void playNote(char note,int duration)
{unsigned char names[]="CDEFGAB";
unsigned int tones[]={
//note tone
 1915 , 1700 , 1519 , 1432 , 1275 , 1136 , 1014 ,
//n+
 1806 , 1603 , 1433 , 1350 , 1202 , 1071 , 956 ,
//n-
 2029 , 1801 , 1610 , 1517 , 1351 , 1204 , 1074};
for (char i=0;i<7;i++) {if (names[i]==note) playTone(tones[i+flagdiez*7] >> octave,duration);}
}


//Main program
//Read music text fron melody[] and plays music

void play(unsigned char *melody)
{unsigned char tmp;unsigned int itmp;
tempo=120;int note1=(int)(240000L/tempo);
for (int i=0;nota != 0;)
  {
//process prefix commands
retry:
   if (nota eq 32) {i++;goto retry;}
   if ((nota eq 't') || (nota eq 'T')) {i++;itmp=0;while (isdigit(nota)) {itmp=itmp*10+(nota-48);i++;}
                                                if (itmp > 0) {tempo=itmp;note1=(int)(240000L/tempo);}
                                                goto retry;}
   if ((nota eq 'm') || (nota eq 'M')) {i++;tmp=nota;i++;if (islower(tmp)) tmp-=32;
                                                if ((tmp eq 'N') || (tmp eq 'S') || (tmp eq 'L')) playmode=tmp;
                                                goto retry;}
   if ((nota eq 'o') || (nota eq 'O')) {i++;octave=nota-48-1;i++;goto retry;}
   if ((nota eq 'l') || (nota eq 'L'))
     {i++;tmp=0;while (isdigit(nota)) {tmp=tmp*10+(nota-48);i++;} if (tmp>0) lendef=tmp;goto retry;}
   if (nota eq '>') {i++;octave++;goto retry;}
   if (nota eq '<') {i++;octave--;goto retry;}
//process note code   
   char notecode=nota;i++;
//process suffix commands
   flagdiez=0;
   while ((nota eq '#') || (nota eq '+') || (nota eq '-')) 
                    {if ((nota eq '#') || (nota eq '+')) flagdiez=1;
                     if (nota eq '-') flagdiez=2;
                     i++;}
   while (nota eq 32) i++;
   char len;
     {tmp=0;while (isdigit(nota)) {tmp=tmp*10+(nota-48);i++;} len=lendef; if (tmp>0) len=tmp;}
   int notelen=note1 / len;
   boolean flagdot=false;
   while (nota eq 32) i++;
   while (nota eq '.') {flagdot=true;i++;}
   if (flagdot) notelen=notelen+(notelen >> 1);                  
//play note
   if (islower(notecode)) notecode-=32;
   if (notecode=='P') delay(notelen); else 
    {if      (playmode eq 'L') {playNote(notecode,notelen);}
     else if (playmode eq 'S') {playNote(notecode,notelen*3/4);delay(notelen/4);}
     else                      {playNote(notecode,notelen*7/8);delay(notelen/8);}
    }
  }
}

void setup()
{unsigned char tmp;unsigned int itmp;
 pinMode(LED,OUTPUT);
 pinMode(SPEAKER,OUTPUT);
 play(notes);
 }

void loop()
{
}

